'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cachedScripts = [];

var getDisplayName = function getDisplayName(name) {
  return 'withScriptLoader(' + name + ')';
};

var withScriptLoader = function withScriptLoader() {
  for (var _len = arguments.length, scripts = Array(_len), _key = 0; _key < _len; _key++) {
    scripts[_key] = arguments[_key];
  }

  return function (WrappedComponent) {
    var ScriptLoader = function (_Component) {
      _inherits(ScriptLoader, _Component);

      function ScriptLoader(props) {
        _classCallCheck(this, ScriptLoader);

        var _this = _possibleConstructorReturn(this, (ScriptLoader.__proto__ || Object.getPrototypeOf(ScriptLoader)).call(this, props));

        _this.loadScripts = function (scripts) {
          var promises = scripts.map(function (script) {
            return (typeof script === 'undefined' ? 'undefined' : _typeof(script)) === 'object' ? script : { src: script };
          }).filter(function (script) {
            return !cachedScripts.includes(script.src);
          }).map(function (script) {
            return _this.loadScript(script);
          });

          Promise.all(promises).then(function () {
            _this._isMounted && _this.setState({
              hasScriptsLoaded: true,
              hasScriptsLoadedSuccessfully: true
            });
          }).catch(function () {
            _this._isMounted && _this.setState({
              hasScriptsLoaded: true,
              hasScriptsLoadedSuccessfully: false
            });
          });
        };

        _this.loadScript = function (_ref) {
          var src = _ref.src,
              attributes = _objectWithoutProperties(_ref, ['src']);

          cachedScripts.push(src);

          var script = document.createElement('script');
          script.src = src;
          Object.keys(attributes).forEach(function (key) {
            return script[key] = attributes[key];
          });

          var promise = new Promise(function (resolve, reject) {
            script.addEventListener('load', function () {
              return resolve(src);
            });
            script.addEventListener('error', function (error) {
              return reject(error);
            });
          }).catch(function (error) {
            var index = cachedScripts.indexOf(src);
            if (index >= 0) cachedScripts.splice(index, 1);
            script.remove();
            throw error;
          });

          document.body.appendChild(script);

          return promise;
        };

        _this._isMounted = false;

        _this.state = {
          hasScriptsLoaded: false,
          hasScriptsLoadedSuccessfully: false
        };
        return _this;
      }

      _createClass(ScriptLoader, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          this._isMounted = true;
          this.loadScripts(scripts);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this._isMounted = false;
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(WrappedComponent, _extends({}, this.props, this.state));
        }
      }]);

      return ScriptLoader;
    }(_react.Component);

    var name = WrappedComponent.displayName || WrappedComponent.name || 'Component';

    ScriptLoader.displayName = getDisplayName(name);
    ScriptLoader.WrappedComponent = WrappedComponent;

    return (0, _hoistNonReactStatics2.default)(ScriptLoader, WrappedComponent);
  };
};

exports.default = withScriptLoader;